
BFC_InfoFrame = {
	headings = {},
	headingFrames = {},
};
BFC_InfoFrameObject = {
	frame,
	heading,
	name,
	visible,
	
};

function BFC_InfoFrame.Init()
	BFC_InfoFrame_singleton = BFC_InfoFrame:new();
	BFC_InfoFrame_Frame:Show();
end

-- Constructor for InfoFrame object
function BFC_InfoFrame:new()
	t = {};
	setmetatable(t, self);
	self.__index = self;
	
	--t.id = BFC_Timer.nextid;
	--BFC_Timer.nextid = BFC_Timer.nextid + 1;
	
	return t;
end


function BFC_InfoFrame:getInstance()
	return BFC_InfoFrame_singleton;
end


function BFC_InfoFrameObject:new(frame, heading, name)
	t = {};
	setmetatable(t, self);
	self.__index = self;
	
	--if frame then
	t.frame = frame;
	t.heading = heading;
	t.name = name;
	--end
	
	return t;
end


function BFC_InfoFrame:addFrame(frame, heading, name)
	self:addObject(BFC_InfoFrameObject:new(frame, heading, name));
end


function BFC_InfoFrame:addObject(obj)
	if(not obj) then
		BFC.Log(BFC.LOG_ERROR, BFC_Strings.Errors.nilobject);
		return
	end
	
	i = 0;
	-- if this is a new heading, create a new fontstring for it.
	if(not self.headings[obj.heading]) then
		BFC.Log(BFC.LOG_DEBUG, "creating heading " .. obj.heading);
		self.headings[obj.heading] = {};
		self.headingFrames[obj.heading] = CreateFrame("Frame", "BFC_InfoFrame_Heading" .. i, BFC_InfoFrame_Frame, "BFC_InfoFrameHeading");
		getglobal(self.headingFrames[obj.heading]:GetName() .. "Text"):SetText(obj.heading);
	else
		BFC.Log(BFC.LOG_DEBUG, "skipping heading creation");
	end
	
	if(self.headings[obj.heading]) then
		BFC.Log(BFC.LOG_DEBUG, "heading " .. obj.heading .. " exists");
	end
	
	self.headings[obj.heading][obj.name] = obj;
	self:update();
end


function BFC_InfoFrame:update()
	local ypos = 0;
	for k,v in pairs(self.headings) do
		f = self.headingFrames[k];
		f:ClearAllPoints();
		f:SetParent(BFC_InfoFrame);
		f:SetPoint("TOPLEFT", "BFC_InfoFrame_Frame", "TOPLEFT", 0, -ypos);
		ypos = ypos + f:GetHeight();
		
		for j,q in pairs(self.headings[k]) do
			q.frame:ClearAllPoints();
			q.frame:SetParent(BFC_InfoFrame);
			q.frame:SetPoint("TOPLEFT", "BFC_InfoFrame_Frame", "TOPLEFT", 0, -ypos);
			ypos = ypos + q.frame:GetHeight();
		end
	end
	
	BFC_InfoFrame:SetHeight(ypos);
end