-- Random utility functions and other handy things

BFC_Util = {};

function BFC_Util.Init()
	BFC_Util.ReverseClassLookup = BFC_Util.FlipKeysAndValues(BFC_Strings.Classes);
end


function BFC_Util.FlipKeysAndValues(table)
	local newTable = {};
	
	for key,val in pairs(table) do
		newTable[val] = key;
	end
	
	return newTable;
end


function BFC_Util.GetRealClassName(class)
	return BFC_Util.ReverseClassLookup[class];
end


-- From lua-users wiki
function BFC_Util.SplitString(delimiter, text)
	local list = {}
	local pos = 1
	if strfind("", delimiter, 1) then -- this would result in endless loops
		error("delimiter matches empty string!")
	end
	while 1 do
		local first, last = strfind(text, delimiter, pos)
		if first then -- found?
			tinsert(list, strsub(text, pos, first-1))
			pos = last+1
		else
			tinsert(list, strsub(text, pos))
			break
		end
	end
	return list
end


-- From wowwiki: count table members even if they're not indexed by numbers
function BFC_Util.TableCount(tab)
	local n=0;
	for _ in pairs(tab) do
		n=n+1;
	end
	return n;
end


-- Get a table item by index even if not indexed by numbers
function BFC_Util.GetTableItem(tab, index)
	local n = 1;
	for _,v in pairs(tab) do
		if(n == index) then
			return v;
		end
		n = n+1;
	end
	BFC.Log(BFC.LOG_ERROR, "Table index out of bounds: " .. index);
	return nil;
end